/*
 * 
 * Copyright (c) 2012 Fawzma.com
 * Copyright (c) 2012 David Fawcett
 * 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */
#import "AppDelegate.h"
#import "HelloWorldLayer.h"



@implementation testingnibAppDelegate
@synthesize window=window_, glView=glView_,menuItems,myWindowController;

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	CCDirectorMac *director = (CCDirectorMac*) [CCDirector sharedDirector];
    [glView_ setFrameSize:NSMakeSize(1024,768)]; 
	// enable FPS and SPF
	[director setDisplayStats:YES];
	
	// connect the OpenGL view with the director
	[director setView:glView_];

	// EXPERIMENTAL stuff.
	// 'Effects' don't work correctly when autoscale is turned on.
	// Use kCCDirectorResize_NoScale if you don't want auto-scaling.
	[director setResizeMode:kCCDirectorResize_AutoScale];
	
	// Enable "moving" mouse event. Default no.
	[window_ setAcceptsMouseMovedEvents:NO];
	
	// Center main window
	[window_ center];
    
    
    if (!menuItems)
    {
        
        menuItems = [[menuitems alloc ]initWithNib:@"menuitems"];
        
        //[[MyWindowController alloc] init];
    }
    
    //modalTaskStatusWindow.window.title = title;
    //[modalTaskStatusWindow.window center];
    //[modalTaskStatusWindow.window makeKeyAndOrderFront:self];
    
    //[[NSApplication sharedApplication] runModalForWindow:modalTaskStatusWindow.window];
    /*
    menuitems = [[NSWindowController alloc]
                 initWithWindowNibName:  @"menuitems"];
    [myWindowController initWithWindow:@"menuitems"];
    [menuitems showWindow: self];
    [window_ addChildWindow:menuitems.window ordered:NSWindowAbove];
    */
    
     //NSWindowController * windowController = [[NSWindowController alloc] initWithWindowNibName:@"menuitems"];
    //[[windowController window] makeKeyAndOrderFront:windowController];
	
	[director runWithScene:[HelloWorldLayer scene:menuItems]];
}

- (BOOL) applicationShouldTerminateAfterLastWindowClosed: (NSApplication *) theApplication
{
	return YES;
}

- (void)dealloc
{
	[[CCDirector sharedDirector] end];
	[window_ release];
	[super dealloc];
}

#pragma mark AppDelegate - IBActions

- (IBAction)toggleFullScreen: (id)sender
{
	CCDirectorMac *director = (CCDirectorMac*) [CCDirector sharedDirector];
	[director setFullScreen: ! [director isFullScreen] ];
}

@end
