/*
 * 
 * Copyright (c) 2012 Fawzma.com
 * Copyright (c) 2012 David Fawcett
 * 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

// Import the interfaces
#import "HelloWorldLayer.h"
#import "staticVars.h"
//@class menuitems;
// HelloWorldLayer implementation
@implementation HelloWorldLayer
@synthesize menuItems;

+(CCScene *) scene:(menuitems*)menu
{
    
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	HelloWorldLayer *layer = [[HelloWorldLayer node]init:menu];
	
    [layer setTag:9999];
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init:(menuitems*)menu
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super init]) ) {
		
        menuItems = menu;
        
		// create and initialize a Label
		CCLabelTTF *label = [CCLabelTTF labelWithString:@"Hello World" fontName:@"Marker Felt" fontSize:64];

		// ask director for the window size
		CGSize size = [[CCDirector sharedDirector] winSize];
	
		// position the label on the center of the screen
		label.position =  ccp( size.width /2 , size.height/2 );
		

        

        CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
        iphone.tag = 9999;
        iphone.position = ccp( size.width /2-6 , size.height/2-4 );
        //[iphone setZOrder:-1];
        
        [self addChild:iphone];
        CCSprite *bgcolor = [CCSprite spriteWithFile:@"bgcolor.png"];
        bgcolor.position = ccp( size.width /2 , size.height/2 );
        bgcolor.tag = 9998;
        [bgcolor setColor:ccc3(255, 255, 255)];
        
        [self addChild:bgcolor];
		// add the label as a child to this Layer
        
        //[self schedule: @selector(update:) interval: 1.0f/60.0f];
		//[self addChild: label];
        //[[CCTouchDispatcher sharedDispatcher] addTargetedDelegate:self priority:0 swallowsTouches:YES];
        //self.isTouchEnabled = YES;
        
        self.isMouseEnabled = YES;
        
        
	}
	return self;
}

-(BOOL)ccMouseDragged:(NSEvent *)event {
    CGPoint clickLocation = [[CCDirector sharedDirector] convertEventToGL:event];
    //NSLog(@"mx = %d, my = %d",(int)clickLocation.x,(int)clickLocation.y);
    [staticVars setCurX:(int)clickLocation.x];
    [staticVars setCurY:(int)clickLocation.y];
    return YES;
}

-(BOOL)ccMouseDown:(NSEvent *)event {
    CGPoint clickLocation = [[CCDirector sharedDirector] convertEventToGL:event];
    
    //NSLog(@"mouse click x = %d",(int)clickLocation.x);
    //[menuItems selectSprite:clickLocation];
    [staticVars setMouseIsDown:YES];
    [staticVars setCurX:(int)clickLocation.x];
    [staticVars setCurY:(int)clickLocation.y];
    return YES;
}

-(BOOL)ccMouseUp:(NSEvent *)event {
    CGPoint clickLocation = [[CCDirector sharedDirector] convertEventToGL:event];
    [staticVars setMouseIsDown:NO];
    [staticVars setCurX:(int)clickLocation.x];
    [staticVars setCurY:(int)clickLocation.y];
    return YES;
}

- (void)update:(id)sender
{
    NSLog(@"TICK");
}

// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	// in case you have something to dealloc, do it in this method
	// in this particular example nothing needs to be released.
	// cocos2d will automatically release all the children (Label)
	
	// don't forget to call "super dealloc"
	[super dealloc];
}
@end
