/*
 * 
 * Copyright (c) 2012 Fawzma.com
 * Copyright (c) 2012 David Fawcett
 * 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#import <Cocoa/Cocoa.h>
#import "cocos2d.h"
#import "MyWindowController.h"

@interface menuitems : MyWindowController{
    IBOutlet NSPopUpButton *comboBox;
    IBOutlet NSTextField *selectedLabel;
    IBOutlet NSTextField *curX;
    IBOutlet NSTextField *curY;
    IBOutlet NSTextField *curR;
    IBOutlet NSTextField *curO;
    
    IBOutlet NSTextField *lblIndex;
    IBOutlet NSSliderCell *rotationValue;
    IBOutlet NSSlider *sliderX;
    IBOutlet NSSlider *sliderY;
    IBOutlet NSSlider *sliderO;
    IBOutlet NSTextField *spriteName;
    IBOutlet NSColorWell *colorWell;
    IBOutlet NSButton *checkBox; //bg color
    IBOutlet NSTextField *textTag;
    IBOutlet NSTextField *textzOrder;
    IBOutlet NSButton *addToSceneButton;
    IBOutlet NSTextField *textScaleXY;
    IBOutlet NSButton *isButton;
    IBOutlet NSTextField *projectName;
    IBOutlet NSButton *includeSelector;
    IBOutlet NSButton *orientaion;
    IBOutlet NSTextField *textSelector;
    IBOutlet NSButton *isIpad;
    
 
    IBOutlet NSSlider *scaleValueXY;
    
    //NSString *_spriteName;
    //CCSprite *_sprite;
    //NSNumber *_posX;                    
    //NSNumber *_posY;
    //NSNumber *_rotation;
    //NSString *_fileName;
    //NSString *_filePath;
    //NSNumber *_zOrder;
    //NSNumber *_tag;
    //NSNumber *_scaleXY;
    //NSNumber *_isButtonCheckbox;
    
    bool updatedName;
    
    CCSprite *curSprite;
    
    
    NSString *curSpriteName;
    int curIndex;
    
    NSMutableArray *spriteContainer;
    //NSMutableDictionary *spriteObject;
    

    NSButton *updateSprite;
    NSColorWell *updateColorWell;
}
@property (nonatomic, retain) CCSprite *curSprite;
@property (nonatomic, retain) NSString *curSpriteName;
@property (nonatomic, retain) NSMutableArray *spriteContainer;
//@property (nonatomic, retain) NSNumber *posX;                    
//@property (nonatomic, retain) NSNumber *posY;
@property (nonatomic,retain) IBOutlet NSTextField *textScaleXY;

//@property (nonatomic, retain) NSNumber curIndex;

- (id)initWithNib:(NSString *)nib;
//- (IBAction)addSprite:(id)sender;
- (IBAction)addToLibrary:(id)sender;
- (IBAction)itemSelected:(id)sender;
- (IBAction)updateSprite:(id)sender;
- (IBAction)updateRotation:(id)sender;
- (IBAction)updateScaleXY:(id)sender;
- (IBAction)updateOpacity:(id)sender;
- (IBAction)setX:(id)sender;
- (IBAction)setY:(id)sender;
- (IBAction)updateColorWell:(id)sender;
- (IBAction)textX:(id)sender;
- (IBAction)textY:(id)sender;
- (IBAction)textR:(id)sender;
- (IBAction)textS:(id)sender;
- (IBAction)textZ:(id)sender;
- (IBAction)textT:(id)sender;
- (IBAction)textO:(id)sender;
- (IBAction)ipadSelected:(id)sender;


- (IBAction)writeFile:(id)sender;
- (void)writeUsingSavePanel;
- (IBAction)openProject:(id)sender;
- (IBAction)addParticle:(id)sender;
- (IBAction)removeItem:(id)sender;
- (IBAction)orientaion:(id)sender;
- (void)selectSprite:(CGPoint)loc;
- (void)addProject:(NSOpenPanel*)panel;


@end
