/*
 * 
 * Copyright (c) 2012 Fawzma.com
 * Copyright (c) 2012 David Fawcett
 * 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */

#import "cocos2d.h"
#import "menuitems.h"
#import "spriteObject.h"
#import "staticVars.h"

@interface menuitems ()

@end

@implementation menuitems
@synthesize curSprite,curSpriteName,spriteContainer,textScaleXY;

-(id) initWithNib:(NSString *)nib
{
    self = [super initWithNib:nib];
    if (self) {
        // Initialization code here.
        //comboBox = [[NSPopUpButton alloc]init];
        spriteContainer = [[NSMutableArray alloc]init];
       
        updatedName = true;
        //posX = [NSNumber numberWithInt:0];
        //posY = [NSNumber numberWithInt:0];
        [NSTimer scheduledTimerWithTimeInterval:1.0f/60.0f
                                         target:self
                                       selector:@selector(update:)
                                       userInfo:nil
                                        repeats:YES];
    }
    
    return self;
}


- (id)initWithWindow:(NSWindow *)window
{
    //if ((self = [super initWithWindowNibName:@"menuitems"]) != nil) {
    
    //}
    //return self;

    
    self = [super initWithWindow:window];
    if (self) {
        // Initialization code here.
        
    }
    
    return self;
}

- (void)windowDidLoad
{
    [super windowDidLoad];

    
    // Implement this method to handle any initialization after your window controller's window has been loaded from its nib file.
}

- (IBAction)addToLibrary:(id)sender
{
    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
        
    }
    
    NSOpenPanel *panel = [NSOpenPanel openPanel];
    [panel setCanChooseDirectories:NO];
    NSArray  * fileTypes = [NSArray arrayWithObjects:@"png",@"plist",@"txt",nil];
    //[panel setAllowedFileTypes:[NSImage imageFileTypes]];
    [panel setAllowedFileTypes:fileTypes];
    
    [panel  beginWithCompletionHandler:^(NSInteger result)
     {
         
         
         
         bool isPlist = false;
         if (result==NSFileHandlingPanelOKButton)
         {
             NSString *name = [panel.URL lastPathComponent];
  
             if([name rangeOfString:@".txt"].length>0){
                 [self addProject:panel];
                 return;
             }
             
             NSRange range = [name rangeOfString:@".plist"];
             if(range.length > 0){
                 isPlist = true;
             }
             
             
             if([spriteName.stringValue isEqualToString:name]){
                 return;
             }
             
             if([comboBox indexOfItemWithTitle:name]>-1)
                 return;
             
             NSImage *aImage = [[NSImage alloc] initWithContentsOfURL:panel.URL];
             
             if (aImage || isPlist==true)
             {
                 [aImage release];
                 
                 updatedName = NO;
                 
                 CGSize size = [[CCDirector sharedDirector] winSize];
                 CCScene *scene = [[CCDirector sharedDirector] runningScene];
                 CCNode *tmplayer = [scene getChildByTag:9999];
                 [tmplayer removeChildByTag:9999 cleanup:YES];
                 CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
                 iphone.position = ccp( size.width /2-6 , size.height/2-4 );
                 [iphone setTag:9999];
                 
                                
                 NSURL*  theDoc = [[panel URLs] objectAtIndex:0];
                 NSString* filePath = [theDoc path];
                 NSLog(@"the path: %@", filePath);
                
                 CCSprite *sprite = nil;
                 if(!isPlist){
                     sprite = [CCSprite spriteWithFile:filePath];
                 }else{
                     sprite = [CCSprite spriteWithFile:@"dot.png"];
                     CCParticleSystemQuad* myEmitter = [CCParticleSystemQuad particleWithFile:@"flame.plist"];
                     CCSprite *tex = [CCSprite spriteWithFile:@"particle.png"];
                     myEmitter.texture = [tex texture];
                     [sprite addChild:myEmitter z:1];
                     
                 }
                 
                 sprite.position = ccp( size.width /2 , size.height/2 );
                 sprite.tag = 1;
                 sprite.zOrder = 1;
                 
                 
                 [comboBox addItemWithTitle:name];
                 [comboBox selectItemWithTitle:name];
                 [selectedLabel setStringValue:[NSString stringWithFormat:@"Selected Item: %@",name]];
                 
                 curIndex = (int)[comboBox indexOfSelectedItem];
                 
                 [lblIndex setStringValue:[NSString stringWithFormat:@"Current Index: %d",curIndex]];
                 
                 CGFloat x = sprite.position.x;
                 NSLog(@"REAL X:%g",x);
                 CGFloat y = sprite.position.y;
                 NSLog(@"REAL Y:%g",y);
                 CGFloat r = sprite.rotation;
                 CGFloat s = sprite.scale;
                 int o = sprite.opacity;
                 
                 curSprite = sprite;
                 
                 //float iphonex = x - 272.0f;
                 float iphonex = x - oViewX;
                 [curX setStringValue:[[NSNumber numberWithFloat:iphonex] stringValue]];
                 [sliderX setFloatValue:iphonex];
                 
                 //float iphoney = y - 224.0f;
                 float iphoney = y - oViewY;
                 [curY setStringValue:[[NSNumber numberWithFloat:iphoney] stringValue]];
                 [sliderY setFloatValue:iphoney];
                 
                 [curO setIntValue:o];
                 [sliderO setIntValue:o];
                 
                 [curR setStringValue:[[NSNumber numberWithFloat:r] stringValue]];
                 [curR setStringValue:@"0.0"];
                 [scaleValueXY setFloatValue:s];
                 [textTag setStringValue:@"1"];
                 [textzOrder setStringValue:@"1"];
                 [textScaleXY setStringValue:@"1.0"];
                 [textSelector setStringValue:@""];
                 
                 isButton.state = 0;
                 
                 [spriteName setStringValue:name];
                
                 spriteObject *sprObj = [[spriteObject alloc]init];
                 sprObj.posX = [NSNumber numberWithFloat:x];
                 sprObj.posY = [NSNumber numberWithFloat:y];
                 sprObj.opacity = [NSNumber numberWithInt:o];
                 sprObj.rotation = [NSNumber numberWithInt:(int)r];
                 sprObj.spriteName = spriteName.stringValue;
                 sprObj.sprite = sprite;
                 sprObj.fileName = name;
                 sprObj.filePath = filePath;
                 sprObj.scaleXY = [NSNumber numberWithFloat:s];
                 sprObj.selector = @"";
                 
                 if(isPlist)
                     sprObj.objType = @"<PARTICLE>";
                 
                 

                 [spriteContainer addObject:sprObj];
                 [tmplayer addChild:sprite];
                 //[tmplayer addChild:iphone];
                 
                 [comboBox setEnabled:NO];
                 [addToSceneButton setEnabled:NO];
                 
                 

                 [tmplayer removeChildByTag:9999 cleanup:YES];
                 iphone.position = ccp( size.width /2-6 , size.height/2-4 );
                 [iphone setTag:9999];
                 [iphone setZOrder:9999];
                 [tmplayer addChild:iphone];
                 
                 [self orientaion:sender];
                 
                 
                 
             }
             else
             {
                 NSLog(@"Error, i can't load image %@ at path %@", name, [panel.URL path]);
             }
         }
         
     }];

    
}


             
- (void)addProject:(NSOpenPanel*)panel{

    NSString *contents = [NSString stringWithContentsOfURL:panel.URL encoding:NSASCIIStringEncoding error:nil];
    if(contents){
        
        //clear combobox
        [comboBox removeAllItems];
        //clear spritecontainer objects
        [spriteContainer removeAllObjects];
        //clear gui fields
        
        
        NSArray *lines = [contents componentsSeparatedByString:@"\n"];
        
        NSString *magicText = (NSString*)[lines objectAtIndex:0];
        if([magicText isNotEqualTo:@"FAWZMA.COM LAYER FORMAT"])
            return;
        CGSize size = [[CCDirector sharedDirector] winSize];
        CCScene *scene = [[CCDirector sharedDirector] runningScene];
        CCNode *tmplayer = [scene getChildByTag:9999];
        [tmplayer removeChildByTag:9999 cleanup:YES];
        CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
        iphone.position = ccp( size.width /2-6 , size.height/2-4 );
        [iphone setTag:9999];
        
        
        [projectName setStringValue:(NSString*)[lines objectAtIndex:1]];
        NSString *orState = (NSString*)[lines objectAtIndex:2];
        if([orState isEqualTo:@"1"]){
            orientaion.state = 1;
        }else{
            orientaion.state = 0;
        }
        
        int state = [orientaion state];
        float oViewX = 0.0f;
        float oViewY = 0.0f;
        
        if(state){
            //landscape mode
            oViewX = 272.0f;
            oViewY = 224.0f;
        }else{
            //portrait
            oViewX = 352.0f;
            oViewY = 144.0f;
        } 
        
        for(int i = 3;i<lines.count;i++){
            NSString *line = (NSString*)[lines objectAtIndex:i];
            
            // NSRange contains = [line rangeOfString:@"#"];
            if([line rangeOfString:@"#"].length >=1)
                continue;
            //NSLog(line);
            if([line isEqualTo:@"<SPRITE>"]){
                i++;
                spriteObject *s = [[spriteObject alloc]init];
                //@synthesize sprite,spriteName,posX,posY,rotation,fileName,filePath,tag,zOrder,scaleXY,isButtonCheckbox,objType;
                s.spriteName = (NSString*)[lines objectAtIndex:i];i++;
                s.posX = (NSNumber*)[lines objectAtIndex:i];i++;
                s.posY = (NSNumber*)[lines objectAtIndex:i];i++;
                s.rotation = (NSNumber*)[lines objectAtIndex:i];i++;
                s.fileName = (NSString*)[lines objectAtIndex:i];i++;
                s.filePath = (NSString*)[lines objectAtIndex:i];i++;
                s.tag = (NSNumber*)[lines objectAtIndex:i];i++;
                s.zOrder = (NSNumber*)[lines objectAtIndex:i];i++;
                s.scaleXY = (NSNumber*)[lines objectAtIndex:i];i++;
                s.opacity = (NSNumber*)[lines objectAtIndex:i];
                
                
                s.isButtonCheckbox = [NSNumber numberWithInt:0];
                s.objType = [NSString stringWithString:@"<SPRITE>"];
                
                s.sprite = [CCSprite spriteWithFile:s.filePath];
                //s.sprite.position = ccp(s.posX.intValue+272,s.posY.intValue+224);
                s.sprite.position = ccp(s.posX.intValue+(int)oViewX,s.posY.intValue+(int)oViewY);
                s.sprite.rotation = s.rotation.floatValue;
                s.sprite.scale = s.scaleXY.floatValue;
                s.sprite.opacity = s.opacity.intValue;
                [spriteContainer addObject:s];
                [tmplayer addChild:s.sprite];
                [comboBox addItemWithTitle:s.spriteName];
            }
            if([line isEqualTo:@"<BUTTON>"]){
                spriteObject *s = [[spriteObject alloc]init];
                //@synthesize sprite,spriteName,posX,posY,rotation,fileName,filePath,tag,zOrder,scaleXY,isButtonCheckbox,objType;
                i++;i++;
                s.spriteName = (NSString*)[lines objectAtIndex:i];i++;
                s.posX = (NSNumber*)[lines objectAtIndex:i];i++;
                s.posY = (NSNumber*)[lines objectAtIndex:i];i++;
                s.rotation = (NSNumber*)[lines objectAtIndex:i];i++;
                s.fileName = (NSString*)[lines objectAtIndex:i];i++;
                //NSString *tpath = (NSString*)[lines objectAtIndex:i];
                // NSString *fpath = [tpath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
                s.filePath = (NSString*)[lines objectAtIndex:i];i++;
                s.tag = (NSNumber*)[lines objectAtIndex:i];i++;
                s.zOrder = (NSNumber*)[lines objectAtIndex:i];i++;
                s.scaleXY = (NSNumber*)[lines objectAtIndex:i];i++;
                s.opacity = (NSNumber*)[lines objectAtIndex:i];i++;
                s.selector = (NSString*)[lines objectAtIndex:i];
                
                s.isButtonCheckbox = [NSNumber numberWithInt:1];
                s.objType = [NSString stringWithString:@"<BUTTON>"];
                
                
                s.sprite = [CCSprite spriteWithFile:s.filePath];
                //s.sprite.position = ccp(s.posX.intValue+272,s.posY.intValue+224);
                s.sprite.position = ccp(s.posX.intValue+(int)oViewX,s.posY.intValue+(int)oViewY);
                s.sprite.rotation = s.rotation.floatValue;
                s.sprite.scale = s.scaleXY.floatValue;
                s.sprite.opacity = s.opacity.intValue;
                [spriteContainer addObject:s];
                [tmplayer addChild:s.sprite];
                [comboBox addItemWithTitle:s.spriteName];
            }
        }
        [tmplayer removeChildByTag:9999 cleanup:YES];
        iphone.position = ccp( size.width /2-6 , size.height/2-4 );
        [iphone setTag:9999];
        [iphone setZOrder:9999];
        [tmplayer addChild:iphone];
        [self orientaion:nil];
    }
        
    
}

- (IBAction)addParticle:(id)sender {
    return;
    CCScene *scene = [[CCDirector sharedDirector] runningScene];
    CCNode *tmplayer = [scene getChildByTag:9999];
    
    CCParticleSystemQuad* myEmitter = [CCParticleSystemQuad particleWithFile:@"flame.plist"];
    
    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
        
    }
    
     NSOpenPanel *panel = [NSOpenPanel openPanel];
     [panel setCanChooseDirectories:NO];
     [panel setAllowedFileTypes:[NSImage imageFileTypes]];
     
     [panel  beginWithCompletionHandler:^(NSInteger result)
     {
         if (result==NSFileHandlingPanelOKButton){
             NSString *name = [panel.URL lastPathComponent];
     
             if([spriteName.stringValue isEqualToString:name]){
                 return;
             }
     
             if([comboBox indexOfItemWithTitle:name]>-1)
                 return;
     
             NSImage *aImage = [[NSImage alloc] initWithContentsOfURL:panel.URL];
     
             if (aImage){
                 
             }
         }
     }];
     
    myEmitter.zOrder = 9999;
    //myEmitter.texture
    
    myEmitter.position = ccp(300,300);
    
    [tmplayer addChild:myEmitter];
}


- (IBAction)removeItem:(id)sender {
     NSString *str = [comboBox titleOfSelectedItem];
    int idx = 0;
    bool ok = false;
    
    for(int i = 0;i<spriteContainer.count;i++){
        spriteObject *s = [spriteContainer objectAtIndex:i];
        if(s.spriteName == str){
            idx = i;
            ok = true;
            CCScene *scene = [[CCDirector sharedDirector] runningScene];
            CCNode *tmplayer = [scene getChildByTag:9999];
            [tmplayer removeChild:s.sprite cleanup:YES];
        }
    }
    
    if(ok){
        [spriteContainer removeObjectAtIndex:idx];
        [comboBox removeItemWithTitle:str];
        [comboBox selectItemAtIndex:0];
        [self itemSelected:sender];
    }
    
}

- (IBAction)orientaion:(id)sender {
    int state = [orientaion state];
    
    CGSize size = [[CCDirector sharedDirector] winSize];
    CCScene *scene = [[CCDirector sharedDirector] runningScene];
    CCNode *tmplayer = [scene getChildByTag:9999];
    CCSprite *iphone = (CCSprite*)[tmplayer getChildByTag:9999];
    CCSprite *bgColor = (CCSprite*)[tmplayer getChildByTag:9998];
    
    if(state){
        //landscape mode
        iphone.rotation = 0.0f;
        bgColor.rotation = 0.0f;
        iphone.position = ccp( size.width /2-6 , size.height/2-4 );
    }else{
        //portrait
        iphone.rotation = 90.0f;
        bgColor.rotation = 90.0f;
        iphone.position = ccp( size.width /2-4 , size.height/2+6 );
    }
}

- (void) update:(ccTime)sender{
    
    if([staticVars mouseIsDown]){
        spriteObject *s = [[spriteObject alloc]init];
        int state = [orientaion state];
        float oViewX = 0.0f;
        float oViewY = 0.0f;
        
        if(state){
            //landscape mode
            oViewX = 272.0f;
            oViewY = 224.0f;
        }else{
            //portrait
            oViewX = 352.0f;
            oViewY = 144.0f;
            
        }
        
        [curX setStringValue:[NSNumber numberWithInt:[staticVars curX]-oViewX].stringValue];
        [curY setStringValue:[NSNumber numberWithInt:[staticVars curY]-oViewY].stringValue];
        
        [self updateSprite:nil];
    }
}


- (IBAction)updateSprite:(id)sender{
    if(spriteName.stringValue==@"")
        return;
    if(spriteName.stringValue==nil)
        return;

    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
        
    }    
    
    NSLog(@"UPDATING SPRITE");
    for(int i = 0;i<spriteContainer.count;i++){
        spriteObject *s = [spriteContainer objectAtIndex:i];
        if([s.sprite isEqualTo:curSprite]){
            
            [comboBox removeItemAtIndex:[comboBox indexOfSelectedItem]];
            
            
            
            s.posX = [NSNumber numberWithInt:curX.intValue];
            //[sliderX setFloatValue:s.posX.floatValue+272.0f];
            [sliderX setFloatValue:s.posX.floatValue+oViewX];
            [curX setStringValue:s.posX.stringValue];
            
            s.posY = [NSNumber numberWithInt:curY.intValue];
            //[sliderY setFloatValue:s.posY.floatValue+224.0f];
            [sliderY setFloatValue:s.posY.floatValue+oViewY];
            [curY setStringValue:s.posY.stringValue];
            
            s.opacity = [NSNumber numberWithInt:curO.intValue];
            [sliderO setIntValue:s.opacity.intValue];
            [curO setStringValue:s.opacity.stringValue];
            
            //s.sprite.position = ccp( s.posX.floatValue+272.0f , s.posY.floatValue+224.0f);
            s.sprite.position = ccp( s.posX.floatValue+oViewX , s.posY.floatValue+oViewY);
            
            s.rotation = [NSNumber numberWithInt:curR.intValue];
            [curR setFloatValue:s.rotation.floatValue];
            [rotationValue setFloatValue:s.rotation.floatValue];
            s.sprite.rotation = s.rotation.floatValue;
            
            s.scaleXY = [NSNumber numberWithFloat:textScaleXY.floatValue];
            [textScaleXY setStringValue:s.scaleXY.stringValue];
            
            [scaleValueXY setFloatValue:s.scaleXY.floatValue];
            s.sprite.scale = s.scaleXY.floatValue;
            
            s.spriteName = spriteName.stringValue;
            
            s.tag = [NSNumber numberWithInt:textTag.stringValue.intValue];
            s.sprite.tag = s.tag.intValue;
            s.sprite.opacity = s.opacity.intValue;
            s.selector = [textSelector stringValue];
            
            
            int zOrder = [NSNumber numberWithInt:textzOrder.stringValue.intValue].intValue;
            
            s.zOrder = [NSNumber numberWithInt:textzOrder.stringValue.intValue];
            
            if([textzOrder intValue] != zOrder)
                s.sprite.zOrder = zOrder; //do not update zorder if its already teh same, it will reset the order

            
            //int ib = isButton.state;
            //isButton.state = ib;
            s.isButtonCheckbox = [NSNumber numberWithInt:isButton.state];
            
            if(s.isButtonCheckbox.intValue){
                //is a button
                s.objType = [NSString stringWithString:@"<BUTTON>"];
                //[textSelector setStringValue:s.selector];
            }else{
                //will need to check for other types in the future
                
                s.objType = [NSString stringWithString:@"<SPRITE>"];;
                
            }
            
           
            //[comboBox setTitle:s.spriteName];
            [comboBox addItemWithTitle:s.spriteName];
            [comboBox selectItemWithTitle:s.spriteName];
            
            CGSize size = [[CCDirector sharedDirector] winSize];
            CCScene *scene = [[CCDirector sharedDirector] runningScene];
            CCNode *tmplayer = [scene getChildByTag:9999];
            [tmplayer removeChildByTag:9999 cleanup:YES];
            CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
            iphone.position = ccp( size.width /2-6 , size.height/2-4 );
            [iphone setTag:9999];
            [iphone setZOrder:9999];
            [tmplayer addChild:iphone];
            [self orientaion:sender];
            break;
        }
    }


    [comboBox setEnabled:YES];
    [addToSceneButton setEnabled:YES];
}

- (IBAction)updateRotation:(id)sender {
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    int v = (int)[rotationValue floatValue];
    curSprite.rotation = (float)v;
    [curR setStringValue:[NSNumber numberWithInt:rotationValue.intValue].stringValue];
}

- (IBAction)updateScaleXY:(id)sender {
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    CGFloat s = (float)[scaleValueXY floatValue];
    curSprite.scale = s;
    [textScaleXY setStringValue:scaleValueXY.stringValue];
    
}

- (IBAction)updateOpacity:(id)sender {
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    int s = (int)[sliderO intValue];
    curSprite.opacity = s;
    [curO setIntValue:sliderO.intValue];    
}

- (IBAction)setX:(id)sender{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];

    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
        
    }      
    
    int x = (int)[sliderX floatValue];
    //x = the virtural spot
    NSLog(@"REAL X:%d",x+(int)oViewX);
    int y = (int)[sliderY floatValue];

    
    //[curSprite setPosition:ccp(x+272.0f,y+224.0f)];
    [curSprite setPosition:ccp(x+oViewX,y+oViewY)];

    [curX setIntValue:(int)x];    
}


- (IBAction)setY:(id)sender{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];

    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
        
    } 
    
    int x = (int)[sliderX floatValue];
    int y = (int)[sliderY floatValue];
    NSLog(@"REAL Y:%d",y+(int)oViewY);
    
    //[curSprite setPosition:ccp(x+272.0f,y+224.0f)];
    [curSprite setPosition:ccp(x+oViewX,y+oViewY)];
    
    [curY setIntValue:(int)y];      
}

- (IBAction)textX:(id)sender
{
    
    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
    } 
    
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    float y = [curY floatValue];
    float x = [curX floatValue];
    
    [sliderY setFloatValue:y];
    [sliderX setFloatValue:x];
    
    //curSprite.position = ccp(x+272.0f,y+224.0f);
    curSprite.position = ccp(x+oViewX,y+oViewY);
    
    //[self setX:sender];
}

- (IBAction)textY:(id)sender
{
    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
    } 
    
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    float y = [curY floatValue];
    float x = [curX floatValue];
    
    [sliderY setFloatValue:y];
    [sliderX setFloatValue:x];
    
    //curSprite.position = ccp(x+272.0f,y+224.0f);
    curSprite.position = ccp(x+oViewX,y+oViewY);
    //[self setY:sender];
}

- (IBAction)textR:(id)sender
{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    [rotationValue setFloatValue:[curR floatValue]];
    [self updateRotation:sender];
}

- (IBAction)textS:(id)sender
{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    [scaleValueXY setFloatValue:[textScaleXY floatValue]];
    [self updateScaleXY:sender];
}

- (IBAction)textZ:(id)sender
{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
 
    
}

- (IBAction)textT:(id)sender
{
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    
}

- (IBAction)textO:(id)sender {
    [comboBox setEnabled:NO];
    [addToSceneButton setEnabled:NO];
    int o = [curO intValue];
    if(o>255)
        o = 255;
    if(o<0)
        o = 0;
    [sliderO setIntValue:o];
    [self updateOpacity:sender];
}

- (IBAction)ipadSelected:(id)sender {
    /*
     int state = [orientaion state];
     
     CGSize size = [[CCDirector sharedDirector] winSize];
     CCScene *scene = [[CCDirector sharedDirector] runningScene];
     CCNode *tmplayer = [scene getChildByTag:9999];
     CCSprite *iphone = (CCSprite*)[tmplayer getChildByTag:9999];
     CCSprite *bgColor = (CCSprite*)[tmplayer getChildByTag:9998];
     
     if(state){
     //landscape mode
     iphone.rotation = 0.0f;
     bgColor.rotation = 0.0f;
     iphone.position = ccp( size.width /2-6 , size.height/2-4 );
     }else{
     //portrait
     iphone.rotation = 90.0f;
     bgColor.rotation = 90.0f;
     iphone.position = ccp( size.width /2-4 , size.height/2+6 );
     }
     
     */
    
    int ipadState = [isIpad state];
    //CGSize size = [[CCDirector sharedDirector] winSize];
    //CCScene *scene = [[CCDirector sharedDirector] runningScene];
    //CCNode *tmplayer = [scene getChildByTag:9999];
    //CCSprite *iphone = (CCSprite*)[tmplayer getChildByTag:9999];
    //CCSprite *bgColor = (CCSprite*)[tmplayer getChildByTag:9998];    
}



- (IBAction)writeFile:(id)sender {
    NSLog(@"WRITING FILE %@",projectName.stringValue);

    //NSString *filename = [NSString stringWithFormat:@"%@.h",projectName.stringValue];
    
   // NSString *file = [NSString stringWithString:@"TESTING"];
    //[file writeToFile:filename atomically:YES encoding:NSASCIIStringEncoding error:nil];
    
    NSOpenPanel* openDlg = [NSOpenPanel openPanel];
    [openDlg setCanChooseFiles:NO];
    [openDlg setCanChooseDirectories:YES];
   
    [openDlg  beginWithCompletionHandler:^(NSInteger result)
     {
         if (result==NSFileHandlingPanelOKButton)
         {
             NSFileManager *fileManager = [NSFileManager defaultManager];

             //NSString *dir = @"/Users/djr2cool/Documents/";
             NSString *hFile = [NSString stringWithFormat:@"%@%@Layer.h",openDlg.directoryURL,projectName.stringValue];
             NSString *mFile = [NSString stringWithFormat:@"%@%@Layer.m",openDlg.directoryURL,projectName.stringValue];
             NSString *pFile = [NSString stringWithFormat:@"%@%@Layer.txt",openDlg.directoryURL,projectName.stringValue];
             
             NSString *nhFile = [NSString stringWithFormat:@"%@%@Node.h",openDlg.directoryURL,projectName.stringValue];
             NSString *nmFile = [NSString stringWithFormat:@"%@%@Node.m",openDlg.directoryURL,projectName.stringValue];
             
             
             NSMutableString *hOutput = [[NSMutableString alloc]init];
             NSMutableString *mOutput = [[NSMutableString alloc]init];
             NSMutableString *nhOutput = [[NSMutableString alloc]init];
             NSMutableString *nmOutput = [[NSMutableString alloc]init];
             
             NSMutableString *properties = [[NSMutableString alloc]init];
             NSMutableString *synthisize = [[NSMutableString alloc]init];
             
             //NSMutableString *menuNodeName = [[NSMutableString alloc]init];
             NSMutableArray *menuNames = [[NSMutableArray alloc]init];

             
             [nhOutput appendString:@"#import <Foundation/Foundation.h>\n"];
             [nhOutput appendString:@"#import \"cocos2d.h\"\n\n"];
             [nhOutput appendFormat:@"@interface %@Node : CCLayer\n\n{\n\n}\n\n",projectName.stringValue];
             [nhOutput appendString:@"+(CCScene *) scene;\n"];
             [nhOutput appendString:@"-(id)findObject:(Class)c :(int)tag;\n\n@end"];
             if(![fileManager fileExistsAtPath:[[NSURL URLWithString:nhFile] path]])
                 [nhOutput writeToURL:[NSURL URLWithString:nhFile] atomically:YES encoding:NSASCIIStringEncoding error:nil];
             
  //H OUTPUT BEGIN            
             [hOutput appendString:@"#import <Foundation/Foundation.h>\n"];
             [hOutput appendString:@"#import \"cocos2d.h\"\n"];
             [hOutput appendFormat:@"#import \"%@Node.h\"\n\n",projectName.stringValue];
             [hOutput appendFormat:@"@interface %@Layer : CCLayer\n",projectName.stringValue];
             [hOutput appendString:@"{\n"];
             bool hasButtons = NO;
             //bool isFirst = YES;
             for(int i = 0;i<spriteContainer.count;i++){
                 spriteObject *s = [spriteContainer objectAtIndex:i];
                 
                 //not ready to write particles to the scenes yet.
                 if([s.objType isEqualToString:@"<PARTICLE"])
                     continue;
                 
                 if(!s.isButtonCheckbox.intValue){
                     //output all the CCSprites
                     //NSLog(@"OUTPUT SPRITE %@",s.spriteName);
                     [hOutput appendFormat:@"  CCSprite *%@;\n",s.spriteName];
                     [properties appendFormat:@"@property (nonatomic,retain) CCSprite* %@;\n",s.spriteName];
                     [synthisize appendFormat:@"%@,",s.spriteName];
                 }else{
                     hasButtons = YES;
                     [hOutput appendFormat:@"  CCMenuItem *%@;\n",s.spriteName];
                     [properties appendFormat:@"@property (nonatomic,retain) CCMenuItem* %@;\n",s.spriteName];
                     [synthisize appendFormat:@"%@,",s.spriteName];
                     //[menuNodeName appendFormat:@"%@",s.spriteName];
                     [menuNames addObject:s.spriteName];
                 }
             }
             
             if(hasButtons){
                 [hOutput appendFormat:@"  CCMenu *menuNode;\n\n"];
                 [properties appendFormat:@"@property (nonatomic,retain) CCMenu* menuNode;\n"];
                 [synthisize appendFormat:@"menuNode"];
                 //menunode will always be this name till a time we get custom menu name
                 //plus this will alway be located at 0,0
             }else{
                 //remove trailing , in synthisis
                 [synthisize substringToIndex:[synthisize length]-1];
             }
             
             [hOutput appendString:@"}\n\n"];
             //[hOutput appendString:@"+(CCScene *) scene;\n\n"];
             [hOutput appendFormat:@"+(CCScene *) scene : (%@Node*) t;\n\n",projectName.stringValue];
             
             [hOutput appendString:@"@end"];
             
             
             [hOutput writeToURL:[NSURL URLWithString:hFile] atomically:YES encoding:NSASCIIStringEncoding error:nil];
 //H OUTPUT END
             
 //NM OUTPUT BEGIN
             [nmOutput appendFormat:@"#import \"%@Node.h\"\n",projectName.stringValue];
             [nmOutput appendFormat:@"#import \"%@Layer.h\"\n\n",projectName.stringValue];
             [nmOutput appendFormat:@"@implementation %@Node\n\n",projectName.stringValue];
             [nmOutput appendString:@"+(CCScene *) scene\n"];
             [nmOutput appendString:@"{\n"];
             [nmOutput appendString:@"	CCScene *scene = [CCScene node];\n"];
             [nmOutput appendFormat:@"	%@Node *layer = [%@Node node];\n",projectName.stringValue,projectName.stringValue];
             [nmOutput appendString:@"    //[layer setTag:<setatag>];\n"];
             [nmOutput appendFormat:@"	[scene addChild: layer];\n"];
             [nmOutput appendString:@"	return scene;\n"];
             [nmOutput appendString:@"}\n\n\n"];
             [nmOutput appendString:@"-(id) init\n"];
             [nmOutput appendString:@"{\n"];
             [nmOutput appendString:@"	if( (self=[super init]) ) {\n"];
             [nmOutput appendFormat:@"        [self addChild:[%@Layer scene : self] z:1 tag:100];\n    }\n    return self;\n}\n",projectName.stringValue];
            
 //NM OUTPUT END
             
 //M OUTPUT BEGIN
             //[self writeUsingSavePanel];
             [mOutput appendFormat:@"#import \"%@Layer.h\"\n\n",projectName.stringValue];
             [mOutput appendFormat:@"#import \"%@Node.h\"\n\n",projectName.stringValue];
             [mOutput appendFormat:@"@implementation %@Layer\n",projectName.stringValue];
             //[mOutput appendString:@"+(CCScene *) scene\n"];
             [mOutput appendFormat:@"%@Node *p;\n\n",projectName.stringValue];
             [mOutput appendFormat:@"+(CCScene *) scene : (%@Node*) t\n",projectName.stringValue];
             [mOutput appendString:@"{\n"];
             [mOutput appendString:@"	p = t;\n"];
             [mOutput appendString:@"	CCScene *scene = [CCScene node];\n"];
             [mOutput appendFormat:@"	%@Layer *layer = [%@Layer node];\n",projectName.stringValue,projectName.stringValue];
             [mOutput appendString:@"    //[layer setTag:<setatag>];\n"];
             [mOutput appendFormat:@"	[scene addChild: layer];\n"];
             [mOutput appendString:@"	return scene;\n"];
             [mOutput appendString:@"}\n\n\n"];
             [mOutput appendString:@"-(id) init\n"];
             [mOutput appendString:@"{\n"];
             [mOutput appendString:@"	if( (self=[super init]) ) {\n"];
             [mOutput appendString:@"       CGSize size = [[CCDirector sharedDirector] winSize];\n"];
             [mOutput appendString:@"       //add objects to self\n"];
             bool menuNodeCreated = false;
             
             NSMutableString *menuItems = [[NSMutableString alloc]init];
             NSMutableArray *selectors = [[NSMutableArray alloc] init];
             
             for(int i = 0;i<spriteContainer.count;i++){
                 spriteObject *s = [spriteContainer objectAtIndex:i];
                 
                 //not ready to write particles to the scenes yet.
                 if([s.objType isEqualToString:@"<PARTICLE"])
                     continue;
                 
                 if(!s.isButtonCheckbox.intValue){
                      
                     [mOutput appendFormat:@"      %@ = [CCSprite spriteWithFile:@\"%@\"];\n",s.spriteName,s.fileName];
                     [mOutput appendFormat:@"      %@.tag = %@;\n",s.spriteName,s.tag];
                     [mOutput appendFormat:@"      %@.zOrder = %@;\n",s.spriteName,s.zOrder];
                     [mOutput appendFormat:@"      %@.opacity = %@;\n",s.spriteName,s.opacity];
                     float px = 0;
                     float py = 0;
                     int state = [orientaion state];

                     if(state){
                         //[pOut appendString:@"1\n"];
                         px = s.posX.floatValue / 480.0f;
                         py = s.posY.floatValue / 320.0f;
                     }else {
                         //[pOut appendString:@"0\n"];
                         px = s.posX.floatValue / 320.0f;
                         py = s.posX.floatValue / 480.0f;
                     }
                    
                     [mOutput appendFormat:@"      %@.position = ccp( size.width * %#.03gf , size.height * %#.03gf );\n",s.spriteName,px,py];
                     [mOutput appendFormat:@"      %@.rotation = %@.0f;\n",s.spriteName,[[NSNumber numberWithFloat:s.rotation.floatValue] stringValue]];
                     
                     NSNumberFormatter *format = [[NSNumberFormatter alloc]init];
                     [format setFormat:@"#.####"];
                     //NSNumber *scale = [NSNumber numberWithFloat:s.scaleXY.floatValue];
                     
                     [mOutput appendFormat:@"      %@.scale = %#.03gf;\n",s.spriteName,s.scaleXY.floatValue];
         
                     [mOutput appendFormat:@"      [self addChild:%@];\n\n",s.spriteName];
                     
                 }else{
                     if(menuNodeCreated == false){
                         menuNodeCreated = true;
                         //create menu node setting it to 0,0
                     }
                     [menuItems appendFormat:@"%@,",s.spriteName];
                     
                     /**
                      deal with buttons
                      make sure an array is defines to hold all the selectors
                      at end we will write out only those selectors
                      OLD - 
                       [mOutput appendFormat:@"      %@ = [CCMenuItemImage itemWithNormalImage:@\"%@\" selectedImage:@\"%@\" target:self selector:@selector(%@Clicked:)];\n",s.spriteName,s.fileName,s.fileName,s.spriteName];
                     **/
                     if(selectors.count==0){
                         [selectors addObject:s.selector];
                     }
                     bool addSel = true;
                     
                     for(int i = 0;i<selectors.count;i++){
                         NSString *str = (NSString*)[selectors objectAtIndex:i];
                         
                         //if(![selectorsWritten containsObject:[selectors objectAtIndex:i]]){
                         //    [selectorsWritten addObject:[selectors objectAtIndex:i]];
                             
                         //}
                         if([str isEqualToString:s.selector])
                             addSel = false;
                         //if([str rangeOfString:s.selector].length<1)
                         //    addSel = true;
                         
                     }
                     if(addSel)
                         [selectors addObject:s.selector]; 
                     
                     //[mOutput appendFormat:@"      %@ = [CCMenuItemImage itemWithNormalImage:@\"%@\" selectedImage:@\"%@\" target:self selector:@selector(%@)];\n",s.spriteName,s.fileName,s.fileName,s.selector];
                     [mOutput appendFormat:@"      %@ = [CCMenuItemImage itemWithNormalImage:@\"%@\" selectedImage:@\"%@\" target:p selector:@selector(%@)];\n",s.spriteName,s.fileName,s.fileName,s.selector];
                     
                     int state = [orientaion state];
                     float px = 0;
                     float py = 0;
                     if(state){
                         //[pOut appendString:@"1\n"];
                         px = s.posX.floatValue / 480.0f;
                         py = s.posY.floatValue / 320.0f;
                     }else {
                         //[pOut appendString:@"0\n"];
                         px = s.posX.floatValue / 320.0f;
                         py = s.posX.floatValue / 480.0f;
                     }
                     //[mOutput appendFormat:@"      %@.position = ccp(%@.0f,%@.0f);\n",s.spriteName,s.posX,s.posY];
                     [mOutput appendFormat:@"      %@.position = ccp(size.width * %#.03gf , size.height * %#.03gf);\n",s.spriteName,px,py];
                     if(s.tag.intValue!=-1)
                         [mOutput appendFormat:@"      %@.tag = %@;\n",s.spriteName,s.tag];
                     
                         [mOutput appendFormat:@"      %@.scale = %#.03gf;\n",s.spriteName,s.scaleXY.floatValue];

                     [mOutput appendFormat:@"      %@.rotation = %@.0f;\n\n",s.spriteName,[NSNumber numberWithFloat:s.rotation.floatValue]];
                     
                 }
             }
             if(menuNodeCreated == true){
                 //link up all the menuitems to the menunode then add that to self
                 [mOutput appendFormat:@"   menuNode = [CCMenu menuWithItems:%@ nil];\n",menuItems];
                 [mOutput appendString:@"   menuNode.position = CGPointZero;\n\n"];
                 [mOutput appendString:@"[self addChild:menuNode z:1000  tag:101];\n"];
             }
             
             if(includeSelector.state){
                 //[mOutput appendString:@"      [self schedule: @selector(update:) interval: 1.0f/60.0f];\n\n"];
                 [mOutput appendString:@"\n\n   [p schedule: @selector(update:) interval: 1.0f/60.0f];\n\n"];
             }
             
             [mOutput appendString:@"   }\n"];
             [mOutput appendString:@"   return self;\n"];
             [mOutput appendString:@"}\n\n\n"];
             if(includeSelector.state){
                 //[mOutput appendString:@"- (void) update:(ccTime)sender"];
                 //[mOutput appendString:@"{\n"];
                 //[mOutput appendString:@"\n"];
                 //[mOutput appendString:@"}\n"];
                 
                 [nmOutput appendString:@"- (void) update:(ccTime)sender"];
                 [nmOutput appendString:@"{\n"];
                 [nmOutput appendString:@"\n"];
                 [nmOutput appendString:@"}\n"];
                 
                 
             }
             //NSEnumerator *e = [menuNames objectEnumerator];
             NSEnumerator *e = [selectors objectEnumerator];
             id object;
             while (object = [e nextObject]) {
                 // do something with object
                 //[mOutput appendFormat:@"- (void) %@(id)sender", (NSString*)object];
                 //[mOutput appendString:@"{\n"];
                 //[mOutput appendString:@"\n"];
                 //[mOutput appendString:@"}\n\n"];
                 
                 [nmOutput appendFormat:@"- (void) %@(id)sender", (NSString*)object];
                 [nmOutput appendString:@"{\n"];
                 [nmOutput appendString:@"\n"];
                 [nmOutput appendString:@"}\n\n"];
                 
             }

                 
             //helper function added to root node file
             [nmOutput appendString:@"-(id) findObject:(Class)c :(int)tag\n"];
             [nmOutput appendString:@"{\n"];
             [nmOutput appendString:@"    CCArray *a = [self getChildByTag:100].children;\n"];
             [nmOutput appendString:@"    for(CCNode *obj in a){\n"];
             [nmOutput appendString:@"        for(id o in obj.children){\n"];
             [nmOutput appendString:@"           CCNode *m;\n"];
             [nmOutput appendString:@"            if([o isKindOfClass:c]){\n"];
             [nmOutput appendString:@"                m = (CCNode*)o;\n"];
             [nmOutput appendString:@"                if(m.tag==tag)\n"];
             [nmOutput appendString:@"                    return m;\n"];
             [nmOutput appendString:@"           }\n"];
             [nmOutput appendString:@"        }\n"];
             [nmOutput appendString:@"    }\n"];
             [nmOutput appendString:@"}\n\n"];
             
             
             //if(menuNodeCreated == true){
                 
             //}
             
             [mOutput appendString:@"- (void) dealloc"];
             [mOutput appendString:@"{\n"];
             [mOutput appendString:@"	[super dealloc];\n"];
             [mOutput appendString:@"}\n"];
             [mOutput appendString:@"@end"];
             [nmOutput appendString:@"@end"];
             
             
             [mOutput writeToURL:[NSURL URLWithString:mFile] atomically:YES encoding:NSASCIIStringEncoding error:nil];
             
             //BOOL exist = [fileManager fileExistsAtPath:[[NSURL URLWithString:nmFile] path]];
             //NSString *tmpstring = [[NSURL URLWithString:nmFile] path];
             
             if(![fileManager fileExistsAtPath:[[NSURL URLWithString:nmFile] path]])
                 [nmOutput writeToURL:[NSURL URLWithString:nmFile] atomically:YES encoding:NSASCIIStringEncoding error:nil];
//M OUTPUT END

//P OUTPUT BEGIN
             NSMutableString *pOut = [[NSMutableString alloc]init];
             [pOut appendString:@"FAWZMA.COM LAYER FORMAT\n"];
             [pOut appendFormat:@"%@\n",projectName.stringValue];
             int state = [orientaion state];
             if(state){
                 [pOut appendString:@"1\n"];
             }else {
                 [pOut appendString:@"0\n"];
             }
             //include the selector flag
             //int cnt = spriteContainer.count;
             for(int i = 0;i<spriteContainer.count;i++){
                 spriteObject *s = [spriteContainer objectAtIndex:i];
                 
                 //not ready to write particles to the scenes yet.
                 if([s.objType isEqualToString:@"<PARTICLE"]){
                     continue;
                     [pOut appendString:@"<PARTICLE>\n"];
                 }
                 
                 if(!s.isButtonCheckbox.intValue){
                     if([s.objType isEqualTo:@"<SPRITE>"]){
                         [pOut appendString:@"<SPRITE>\n"];
                     }
                 }else{
                     if([s.objType isEqualTo:@"<BUTTON>"]){
                         [pOut appendString:@"<BUTTON>\n"];
                         [pOut appendFormat:@"%@\n",s.isButtonCheckbox.stringValue];
                     }
                 }
                 [pOut appendFormat:@"%@\n",s.spriteName];
                 [pOut appendFormat:@"%@\n",s.posX];
                 [pOut appendFormat:@"%@\n",s.posY];
                 [pOut appendFormat:@"%@\n",s.rotation];
                 [pOut appendFormat:@"%@\n",s.fileName];
                 [pOut appendFormat:@"%@\n",s.filePath];
                 [pOut appendFormat:@"%@\n",s.tag];
                 [pOut appendFormat:@"%@\n",s.zOrder];
                 [pOut appendFormat:@"%@\n",s.scaleXY];
                 [pOut appendFormat:@"%@\n",s.opacity];
                 if(s.isButtonCheckbox.intValue)
                     [pOut appendFormat:@"%@\n",s.selector];
                 
             }
             [pOut writeToURL:[NSURL URLWithString:pFile] atomically:YES encoding:NSASCIIStringEncoding error:nil]; 
//P OUTPUT END
         }else{
             return;
         }
     }];
    

}

- (IBAction)openProject:(id)sender {
    // NSLog(@"Current directory - %@",[[NSBundle mainBundle] bundlePath]);

    
    NSOpenPanel *panel = [NSOpenPanel openPanel];
    [panel setCanChooseDirectories:NO];
    //[panel setAllowedFileTypes:[NSImage imageFileTypes]];
   
    
    [panel  beginWithCompletionHandler:^(NSInteger result)
     {
         if (result==NSFileHandlingPanelOKButton)
         {
             //NSString *name = [panel.URL lastPathComponent];
             //NSURL*  theDoc = [[panel URLs] objectAtIndex:0];
             //NSString* filePath = [theDoc path];
             
             //NSImage *aImage = [[NSImage alloc] initWithContentsOfURL:panel.URL];
             
             NSString *contents = [NSString stringWithContentsOfURL:panel.URL encoding:NSASCIIStringEncoding error:nil];
             if(contents){
                 
                 //clear combobox
                 [comboBox removeAllItems];
                 //clear spritecontainer objects
                 [spriteContainer removeAllObjects];
                 //clear gui fields
                 
                 
                 NSArray *lines = [contents componentsSeparatedByString:@"\n"];
                 
                 NSString *magicText = (NSString*)[lines objectAtIndex:0];
                 if([magicText isNotEqualTo:@"FAWZMA.COM LAYER FORMAT"])
                     return;
                 CGSize size = [[CCDirector sharedDirector] winSize];
                 CCScene *scene = [[CCDirector sharedDirector] runningScene];
                 CCNode *tmplayer = [scene getChildByTag:9999];
                 [tmplayer removeChildByTag:9999 cleanup:YES];
                 CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
                 iphone.position = ccp( size.width /2-6 , size.height/2-4 );
                 [iphone setTag:9999];
                 
                 
                 [projectName setStringValue:(NSString*)[lines objectAtIndex:1]];
                 NSString *orState = (NSString*)[lines objectAtIndex:2];
                 if([orState isEqualTo:@"1"]){
                     orientaion.state = 1;
                 }else{
                     orientaion.state = 0;
                 }

                 int state = [orientaion state];
                 float oViewX = 0.0f;
                 float oViewY = 0.0f;
                 
                 if(state){
                     //landscape mode
                     oViewX = 272.0f;
                     oViewY = 224.0f;
                 }else{
                     //portrait
                     oViewX = 352.0f;
                     oViewY = 144.0f;
                 } 
                 
                 for(int i = 3;i<lines.count;i++){
                     NSString *line = (NSString*)[lines objectAtIndex:i];
                     
                    // NSRange contains = [line rangeOfString:@"#"];
                     if([line rangeOfString:@"#"].length >=1)
                         continue;
                     //NSLog(line);
                     if([line isEqualTo:@"<SPRITE>"]){
                         i++;
                         spriteObject *s = [[spriteObject alloc]init];
                         //@synthesize sprite,spriteName,posX,posY,rotation,fileName,filePath,tag,zOrder,scaleXY,isButtonCheckbox,objType;
                         s.spriteName = (NSString*)[lines objectAtIndex:i];i++;
                         s.posX = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.posY = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.rotation = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.fileName = (NSString*)[lines objectAtIndex:i];i++;
                         s.filePath = (NSString*)[lines objectAtIndex:i];i++;
                         s.tag = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.zOrder = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.scaleXY = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.opacity = (NSNumber*)[lines objectAtIndex:i];
                         s.isButtonCheckbox = [NSNumber numberWithInt:0];
                         s.objType = [NSString stringWithString:@"<SPRITE>"];
                         s.sprite = [CCSprite spriteWithFile:s.filePath];
                         //s.sprite.position = ccp(s.posX.intValue+272,s.posY.intValue+224);
                         s.sprite.position = ccp(s.posX.intValue+(int)oViewX,s.posY.intValue+(int)oViewY);
                         s.sprite.rotation = s.rotation.floatValue;
                         s.sprite.scale = s.scaleXY.floatValue;
                         s.sprite.opacity = s.opacity.intValue;
                         [spriteContainer addObject:s];
                         [tmplayer addChild:s.sprite];
                         [comboBox addItemWithTitle:s.spriteName];
                     }
                     if([line isEqualTo:@"<BUTTON>"]){
                         spriteObject *s = [[spriteObject alloc]init];
                         //@synthesize sprite,spriteName,posX,posY,rotation,fileName,filePath,tag,zOrder,scaleXY,isButtonCheckbox,objType;
                         i++;i++;
                         s.spriteName = (NSString*)[lines objectAtIndex:i];i++;
                         s.posX = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.posY = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.rotation = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.fileName = (NSString*)[lines objectAtIndex:i];i++;
                         //NSString *tpath = (NSString*)[lines objectAtIndex:i];
                        // NSString *fpath = [tpath stringByReplacingOccurrencesOfString:@" " withString:@"%20"];
                         s.filePath = (NSString*)[lines objectAtIndex:i];i++;
                         s.tag = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.zOrder = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.scaleXY = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.opacity = (NSNumber*)[lines objectAtIndex:i];i++;
                         s.selector = (NSString*)[lines objectAtIndex:i];
                         
                         
                         s.isButtonCheckbox = [NSNumber numberWithInt:1];
                         s.objType = [NSString stringWithString:@"<BUTTON>"];
                         s.sprite = [CCSprite spriteWithFile:s.filePath];
                         //s.sprite.position = ccp(s.posX.intValue+272,s.posY.intValue+224);
                         s.sprite.position = ccp(s.posX.intValue+(int)oViewX,s.posY.intValue+(int)oViewY);
                         s.sprite.rotation = s.rotation.floatValue;
                         s.sprite.scale = s.scaleXY.floatValue;
                         s.sprite.opacity = s.opacity.intValue;
                         
                         [spriteContainer addObject:s];
                         [tmplayer addChild:s.sprite];
                         [comboBox addItemWithTitle:s.spriteName];
                     }
                 }
                 
                 [tmplayer removeChildByTag:9999 cleanup:YES];
                 iphone.position = ccp( size.width /2-6 , size.height/2-4 );
                 [iphone setTag:9999];
                 [iphone setZOrder:9999];
                 [tmplayer addChild:iphone];
                 [self orientaion:sender];
                 
             }

         }
     }];
    
    //NSString *contents = [NSString stringWithContentsOfFile:@"/Users/davidw/Desktop/dict_body"];
    //NSArray *lines = [contents componentsSeparatedByString:@"\n"];
    
    
}




- (void)writeUsingSavePanel { 
    // create the string to be written 
    //NSString * zStr = [[NSString alloc]init];
    //NSInteger i;
    //for (i = 0; i < 5; i++) {
    //    zStr = [zStr stringByAppendingFormat:@"i=%d\n",i];
    //} 
    NSString *file = [NSString stringWithString:@"TESTING"];
    // get the file url 

    NSSavePanel * zSavePanel = [NSSavePanel savePanel]; 
    NSInteger zResult = [zSavePanel runModal]; 
    if (zResult == NSFileHandlingPanelCancelButton) { 
        NSLog(@"writeUsingSavePanel cancelled");
        return; 
    }
    NSURL *zUrl = [zSavePanel URL];

    //write BOOL 
    BOOL zBoolResult = [file writeToURL:zUrl atomically:YES encoding:NSASCIIStringEncoding error:NULL]; 
    if (! zBoolResult) { 
        NSLog(@"writeUsingSavePanel failed");
    } 
    
   
}


- (IBAction)updateColorWell:(id)sender {
    
    
    
    GLfloat r = [[colorWell color] redComponent]*255.0f;
    GLfloat g = [[colorWell color] greenComponent]*255.0f;
    GLfloat b = [[colorWell color] blueComponent]*255.0f;
    
    if([checkBox state] == NSOnState){
        CCScene *scene = [[CCDirector sharedDirector] runningScene];
        
        
        CCNode *tmplayer = [scene getChildByTag:9999];
        CCSprite *bgcolor = (CCSprite*)[tmplayer getChildByTag:9998];
        
        [bgcolor setColor:ccc3(r, g, b)];
    }
    
}

- (IBAction)itemSelected:(id)sender {

    int state = [orientaion state];
    float oViewX = 0.0f;
    float oViewY = 0.0f;
    
    if(state){
        //landscape mode
        oViewX = 272.0f;
        oViewY = 224.0f;
    }else{
        //portrait
        oViewX = 352.0f;
        oViewY = 144.0f;
    } 
    
    NSString *str = [comboBox titleOfSelectedItem];
    
    for(int i = 0;i<spriteContainer.count;i++){
        spriteObject *s = [spriteContainer objectAtIndex:i];
        if(s.spriteName == str){
            
            self.curSprite = s.sprite;
            //_posX = s.posX;
            //_posY = s.posY;
            //_rotation = s.rotation;
            //_spriteName = s.spriteName;
            //_sprite = s.sprite;
            //_fileName = s.fileName;
            //_fileName = s.filePath;
            //_zOrder = s.zOrder;
            //_tag = s.tag;
            //_scaleXY = s.scaleXY;
            //_isButtonCheckbox = s.isButtonCheckbox;


            [textScaleXY setStringValue:(NSString*)s.scaleXY];
            //[scaleValueXY setFloatValue:_scaleXY.floatValue];
            [scaleValueXY setFloatValue:s.scaleXY.floatValue];
            
            [textTag setIntValue:s.tag.intValue];
            [textzOrder setIntValue:s.zOrder.intValue];
            
            [spriteName setStringValue:s.spriteName];
            
            //NSNumber *iphonex = [NSNumber numberWithInt:(int)(s.sprite.position.x - 272.f)];
            NSNumber *iphonex = [NSNumber numberWithInt:(int)(s.sprite.position.x - oViewX)];
            [curX setStringValue:iphonex.stringValue ];// s.posX.stringValue];
            [sliderX setFloatValue:iphonex.floatValue];// s.posX.floatValue];
            
            //NSNumber *iphoney = [NSNumber numberWithInt:(int)(s.sprite.position.y - 224.0f)];
            NSNumber *iphoney = [NSNumber numberWithInt:(int)(s.sprite.position.y - oViewY)];
            [curY setStringValue:iphoney.stringValue];//s.posY.stringValue];
            [sliderY setFloatValue:iphoney.floatValue];//s.posY.floatValue];
            
            //[curR setStringValue:s.rotation.stringValue];
            [curR setFloatValue:s.rotation.floatValue];
            
            [curO setIntValue:s.opacity.intValue];
            
            
            
            isButton.state = s.isButtonCheckbox.intValue;// _isButtonCheckbox.intValue;
            if(s.isButtonCheckbox.intValue)
                [textSelector setStringValue:s.selector];
            
            CGSize size = [[CCDirector sharedDirector] winSize];
            CCScene *scene = [[CCDirector sharedDirector] runningScene];
            CCNode *tmplayer = [scene getChildByTag:9999];
            [tmplayer removeChildByTag:9999 cleanup:YES];
            CCSprite *iphone = [CCSprite spriteWithFile:@"iphone.png"];
            iphone.position = ccp( size.width /2-6 , size.height/2-4 );
            [iphone setTag:9999];
            [iphone setZOrder:9999];
            [tmplayer addChild:iphone];
            [self orientaion:sender];
            break;
        }
    }
    
    [selectedLabel setStringValue:[NSString stringWithFormat:@"Selected Item: %@",str]];
    curIndex = (int)[comboBox indexOfSelectedItem];
    [lblIndex setStringValue:[NSString stringWithFormat:@"Current Index: %d",curIndex]];
    
    
    
}

- (void)selectSprite:(CGPoint)loc
{
    NSLog(@"TEST METHOD");
    //CCSprite * newSprite = nil;
    NSMutableArray *tmp = [spriteContainer copy];
    int idx = -1;
    for(int i = tmp.count-1;i>-1;i--){
        spriteObject *s = (spriteObject*)[tmp objectAtIndex:i];
        CCSprite *sprite = (CCSprite*)s.sprite;
        if (CGRectContainsPoint(sprite.boundingBox, loc)) {            
            idx = i;
            break;
        }
    }
    if(idx>-1){
        [comboBox selectItemAtIndex:idx];
        [self itemSelected:nil];
    }
    [tmp release];
    tmp = nil;
    /*
    CCSprite * newSprite = nil;
    for (CCSprite *sprite in movableSprites) {
        if (CGRectContainsPoint(sprite.boundingBox, touchLocation)) {            
            newSprite = sprite;
            break;
        }
    }    
    if (newSprite != selSprite) {
        [selSprite stopAllActions];
        [selSprite runAction:[CCRotateTo actionWithDuration:0.1 angle:0]];
        CCRotateTo * rotLeft = [CCRotateBy actionWithDuration:0.1 angle:-4.0];
        CCRotateTo * rotCenter = [CCRotateBy actionWithDuration:0.1 angle:0.0];
        CCRotateTo * rotRight = [CCRotateBy actionWithDuration:0.1 angle:4.0];
        CCSequence * rotSeq = [CCSequence actions:rotLeft, rotCenter, rotRight, rotCenter, nil];
        [newSprite runAction:[CCRepeatForever actionWithAction:rotSeq]];            
        selSprite = newSprite;
    }
    */
}

- (void)dealloc
{
    [comboBox release];
    [selectedLabel release];
    [curX release];
    [curY release];
    [curR release];
    [lblIndex release];
    [rotationValue release];
    [sliderX release];
    [sliderY release];
    [spriteName release];
    [colorWell release];
    [checkBox release];
    [textTag release];
    [textzOrder release];
    [addToSceneButton release];
    [textScaleXY release];
    [isButton release];
    [projectName release];
    [includeSelector release];
    [orientaion release];
    [scaleValueXY release];
    [curSprite release];
    [curSpriteName release];
    [updateSprite release];
    [updateColorWell release];
    
    [spriteContainer release];
    spriteContainer = nil;
    [super dealloc];
}

- (IBAction)addSprite:(id)sender
{
    /*
    if(spriteName.stringValue == @"")
        return;
    if(spriteName.stringValue == nil)
        return;
    NSLog(@"PRESSED");
    CCScene *scene = [[CCDirector sharedDirector] runningScene];
    
    // ask director for the window size
    CGSize size = [[CCDirector sharedDirector] winSize];

    
    CCSprite *sprite = [CCSprite spriteWithFile:@"/Users/djr2cool/Documents/ART/9.png"];

    sprite.position = ccp( size.width /2 , size.height/2 );
    [scene addChild:sprite];
    */
}



@end
